part of xwidgetbase;

class XfxSchedaTabbed extends StatefulWidget {
  XfxSchedaTabbed({
    Key? key,
    this.titleScheda = "",
    this.backgroudColorOfScheda,
    this.visibleXContainerWithLabelOnTop = true,
    this.listOfChildren,
    this.childrenOfTabViewer,
    this.numberOfTabs,
    this.tabs,
    this.bottomNavigationBarvisible = true,
    this.isScrollableTabs = false,
    this.onTapOnBTNofMenu,
    this.currentIndexOfBottomMenu,
    this.backgroundColorTabs,
    this.onTapForGestureInSch,
    this.horizontalMarginOfElenco,
    this.textStyleOfElTitle,
    required this.childrenOfBottomBar,
    this.sch_Decoration,
    this.borderVisible,
  }) : super(key: key);
  final String titleScheda;
  final bool visibleXContainerWithLabelOnTop;
  final List<Widget>? listOfChildren;
  final List<Widget>? childrenOfTabViewer;
  final int? numberOfTabs;
  final bool? bottomNavigationBarvisible;
  final List<Widget>? tabs;
  final bool? isScrollableTabs;
  final Decoration? sch_Decoration;
  Function()? onTapForGestureInSch;
  final int? currentIndexOfBottomMenu;
  final Function(int)? onTapOnBTNofMenu;
  final double? horizontalMarginOfElenco;
  List<BottomNavigationBarItem> childrenOfBottomBar;
  final Color? backgroundColorTabs;
  final Color? backgroudColorOfScheda;
  final TextStyle? textStyleOfElTitle;
  final bool? borderVisible;
  @override
  _XfxSchedaTabbedState createState() => _XfxSchedaTabbedState();
}

late TabController? tabController;

tabViewerPagesSch(String titleScheda, Widget? childOfSchedaTabViewer, List<BottomNavigationBarItem> childrenOfBottomBar) {
  return XfxScheda(bottomNavigationBarvisible: false, titleScheda: titleScheda, child: childOfSchedaTabViewer, childrenOfBottomBar: childrenOfBottomBar);
}

templateSchedaViewerSch(
  String subTitle,
  String descr,
) {
  return Column(
    children: [
      SizedBox(height: 5),
      XContainerWithLabel(
        subTitle,
        color: XColors.backgroundDark,
        alignmentContainer: Alignment.centerLeft,
        textStyle: XStyles.xStyTextForLabel(),
      ),
      SizedBox(height: 5),
      XContainerWithLabel(
        descr,
        color: XColors.backgroundDark,
        alignmentContainer: Alignment.centerLeft,
        textAlignment: TextAlign.left,
        textStyle: XStyles.xStyTextForLabel(),
      ),
    ],
  );
}

tabPagesSch(
  IconData icon,
  String? label, {
  XTabItem? item,
  TextStyle? labelStyle_ALL,
  TextStyle? labelStyle_Active,
  TextStyle? labelStyle_Disabled,
  Color? labelColor_ALL,
  Color? labelColor_Active,
  Color? labelColor_Disabled,
  Color? iconsColor_ALL,
  Color? iconsColor_Active,
  Color? iconsColor_Disabled,
}) {
  Color getTabItem_IconColor(XTabItem item, int idx) {
    if (item.idx == idx) {
      return item.iconColor_Active ?? iconsColor_Active ?? iconsColor_ALL ?? XColors.foregroundDark;
    } else {
      return item.iconColor_Disabled ?? iconsColor_Disabled ?? iconsColor_ALL ?? XColors.foregroundLight;
    }
  }

  Color getTabItem_LabelColor(XTabItem item, int idx) {
    if (item.idx == idx) {
      return item.labelColor_Active ?? labelColor_Active ?? iconsColor_Active ?? labelColor_ALL ?? iconsColor_ALL ?? XColors.foregroundDark;
    } else {
      return item.labelColor_Disabled ?? labelColor_Disabled ?? labelColor_ALL ?? iconsColor_Disabled ?? iconsColor_ALL ?? XColors.foregroundLight;
    }
  }

  return Tab(
      icon: Icon(icon, color: iconsColor_ALL ?? getTabItem_IconColor(item!, tabController!.index)),
      child: Text(
        label ?? "",
        style: labelStyle_ALL ?? XStyles.xStyTextForDescr(getTabItem_LabelColor(item!, tabController!.index)),
      ));
}

class _XfxSchedaTabbedState extends State<XfxSchedaTabbed> with SingleTickerProviderStateMixin {
  @override
  void initState() {
    tabController = TabController(length: widget.tabs!.length, vsync: this);
    tabController!.addListener(() {
      setState(() {});
    });
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return DefaultTabController(
        length: widget.numberOfTabs!,
        child: Scaffold(
            backgroundColor: widget.backgroudColorOfScheda,
            body: Container(
                decoration: widget.sch_Decoration,
                margin: EdgeInsets.symmetric(horizontal: widget.horizontalMarginOfElenco ?? 15),
                child: Column(children: [
                  widget.visibleXContainerWithLabelOnTop == true ? SizedBox(height: 10) : SizedBox(height: 0),
                  widget.visibleXContainerWithLabelOnTop == true
                      ? Row(
                          children: [
                            Expanded(child: XContainerWithLabel(widget.titleScheda, height: 30, color: XColors.backGroundTitleContainerForScheda_MAIN, textStyle: widget.textStyleOfElTitle ?? TextStyle(fontSize: 18))),
                          ],
                        )
                      : Container(),
                  widget.visibleXContainerWithLabelOnTop == true ? SizedBox(height: 3) : SizedBox(height: 0),
                  TabBar(
                    controller: tabController,
                    indicator: BoxDecoration(color: widget.backgroundColorTabs),
                    isScrollable: widget.isScrollableTabs!,
                    tabs: widget.tabs!,
                    onTap: (idx) {
                      FocusScopeNode currentFocus = FocusScope.of(context);
                      if (!currentFocus.hasPrimaryFocus && currentFocus.focusedChild != null) {
                        FocusManager.instance.primaryFocus?.unfocus();
                      }
                    },
                  ),
                  Expanded(
                      child: Container(
                          decoration: (widget.borderVisible ?? false) //
                              ? BoxDecoration(color: XColors.backgroundDark, border: Border.all(color: widget.backgroundColorTabs ?? Colors.transparent, width: 2)) //
                              : null,
                          child: TabBarView(
                            children: widget.childrenOfTabViewer!,
                            controller: tabController,
                          ))),
                  SizedBox(height: 5),
                ])),
            bottomNavigationBar: widget.bottomNavigationBarvisible == true
                ? BottomNavigationBar(
                    type: BottomNavigationBarType.fixed,
                    currentIndex: widget.currentIndexOfBottomMenu ?? 0,
                    onTap: widget.onTapOnBTNofMenu,
                    enableFeedback: true,
                    showUnselectedLabels: true,
                    selectedItemColor: Colors.blue[700],
                    selectedFontSize: 15,
                    selectedLabelStyle: XStyles.xStyleText(),
                    backgroundColor: Colors.grey[900],
                    unselectedItemColor: XColors.foregroundLight,
                    unselectedFontSize: 10,
                    unselectedLabelStyle: XStyles.xStyleText(),
                    iconSize: 20,
                    items: widget.childrenOfBottomBar,
                  )
                : Container(height: 1)));
  }
}
